package com.elektrimasinad.aho.client;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.elektrimasinad.aho.shared.Company;
import com.elektrimasinad.aho.shared.Department;
import com.elektrimasinad.aho.shared.Measurement;
import com.elektrimasinad.aho.shared.Raport;
import com.elektrimasinad.aho.shared.Unit;
import com.google.gwt.cell.client.SafeHtmlCell;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.logical.shared.ResizeEvent;
import com.google.gwt.event.logical.shared.ResizeHandler;
import com.google.gwt.event.logical.shared.SelectionEvent;
import com.google.gwt.event.logical.shared.SelectionHandler;
import com.google.gwt.i18n.client.DateTimeFormat;
import com.google.gwt.i18n.client.TimeZone;
import com.google.gwt.resources.client.CssResource.NotStrict;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import com.google.gwt.storage.client.Storage;
import com.google.gwt.user.cellview.client.CellTable;
import com.google.gwt.user.cellview.client.Column;
import com.google.gwt.user.cellview.client.TextColumn;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DeckPanel;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.TreeItem;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

public class Raports implements EntryPoint {
	
	private static final DeviceTreeServiceAsync deviceTreeService = DeviceCard.getDevicetreeservice();
	private AsyncCallback<String> storeRaportCallback;
	private AsyncCallback<List<Raport>> getRaportsCallback;
	protected AsyncCallback<List<Measurement>> getRaportDataCallback;
	
	private int MAIN_WIDTH = 900;
	private int CONTENT_WIDTH = (int) (MAIN_WIDTH * 0.9);
	
	private List<Raport> raports = new ArrayList<Raport>();
	private static List<Measurement> raportDataList;

	private DeviceTree devTree;
	private VerticalPanel mainPanel = new VerticalPanel();
	private VerticalPanel raportPanel = new VerticalPanel();
	private DeckPanel contentPanel;
	private VerticalPanel treePanel;
	private VerticalPanel unitPanel = new VerticalPanel();
	
	private Unit selectedUnit;
	private static Raport selectedRaport;
	protected Company selectedCompany;
	protected Department selectedDepartment;
	private Widget inputRaportNr;
	private Widget inputMeasurerName;
	private Widget inputMeasurerPhone;
	private Widget inputDate;
	private boolean isDevMode;
	private boolean isMobileView;
	private Storage sessionStore;
	private String accountKey = null;
	private AsyncCallback<Company> getCompanyCallback;
	DebugClientSide Debug = new DebugClientSide();

	

	@Override
	public void onModuleLoad() {
		Debug.enable();
		if (Window.Location.getHref().contains("127.0.0.1")) isDevMode = true;
		else isDevMode = false;
		if (Window.getClientWidth() < 1000) {
			isMobileView = true;
		} else {
			isMobileView = false;
		}
		Window.addResizeHandler(new ResizeHandler() {

		    @Override
		    public void onResize(ResizeEvent event) {
		    	if (Window.getClientWidth() < 1000) {
					isMobileView = true;
				} else {
					isMobileView = false;
				}
		    	updateWidgetSizes();
		    }
		});
		sessionStore = Storage.getSessionStorageIfSupported();
		accountKey = sessionStore.getItem("Account");
		if ( accountKey == null) {
			Window.Location.assign("/Login.html");
			return;
		} 
			HorizontalPanel navigationPanel = new HorizontalPanel();
			getCompanyCallback = new AsyncCallback<Company>() {

				@Override
				public void onFailure(Throwable arg0) {
					// TODO Auto-generated method stub
					
				}

				@Override
				public void onSuccess(Company arg0) {
					// TODO Auto-generated method stub
					selectedCompany = arg0;
					Label companyNameLabel = new Label(selectedCompany.getCompanyName());
					companyNameLabel.setStyleName("companyLabel");
					Button logoutButton = new Button("Logi v\u00E4lja", new ClickHandler() {

						@Override
						public void onClick(ClickEvent arg0) {
							// TODO Auto-generated method stub
							sessionStore.clear();
							Window.Location.assign("/Login.html");
						}
						
					});
					logoutButton.setStyleName("loginBtn");
					navigationPanel.add(companyNameLabel);
					navigationPanel.add(logoutButton);
				}
			};
		
		storeRaportCallback = new AsyncCallback<String>() {
			
			@Override
			public void onSuccess(String name) {
				System.out.println(name);
				deviceTreeService.getRaports(selectedUnit.getUnitKey(), getRaportsCallback);
			}
			
			@Override
			public void onFailure(Throwable caught) {
				System.err.println(caught);
			}
			
		};
		getRaportsCallback = new AsyncCallback<List<Raport>>() {
			
			@Override
			public void onSuccess(List<Raport> raportList) {
				//System.out.println(name);
				if (raportList != null) {
					raports = raportList;
				}
				createUnitPanel();
				contentPanel.showWidget(contentPanel.getWidgetIndex(unitPanel));
				updateWidgetSizes();
			}
			
			@Override
			public void onFailure(Throwable caught) {
				System.err.println(caught);
			}
			
		};
		getRaportDataCallback = new AsyncCallback<List<Measurement>>() {
			
			@Override
			public void onSuccess(List<Measurement> measurementList) {
				//System.out.println(name);
				if (measurementList != null) {
					raportDataList = measurementList;
				}
				if (selectedRaport.getRaportKey().equals("")) {
					createRaport(true);
				} else {
					createRaport(false);
				}
				updateWidgetSizes();
			}
			
			@Override
			public void onFailure(Throwable caught) {
				System.err.println(caught);
			}
			
		};
		
		RootPanel root = RootPanel.get();
		root.setStyleName("mainBackground2");
		
		mainPanel.setStyleName("panelBackground");
		
		Image headerImage = new Image("res/hes-symbol.jpg");
		headerImage.setStyleName("aho-headerImage");
		headerImage.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				if(isDevMode) Window.Location.assign(Window.Location.getHref().replace("index", "index"));
				else Window.Location.assign("/Index.html");
			}
			
		});
		
		
//		HorizontalPanel navigationPanel = new HorizontalPanel();
		navigationPanel.setStyleName("aho-navigationPanel");
		navigationPanel.add(headerImage);
		navigationPanel.setCellWidth(headerImage, "52px");
		deviceTreeService.getCompany(sessionStore.getItem("Account"), getCompanyCallback);

		AbsolutePanel headerPanel = new AbsolutePanel();		
		headerPanel.setStyleName("headerBackground");
		headerPanel.add(navigationPanel);
		mainPanel.add(headerPanel);
		
		contentPanel = new DeckPanel();
		mainPanel.add(contentPanel);
		mainPanel.setCellHeight(contentPanel, "100%");
		mainPanel.setCellHorizontalAlignment(contentPanel, HasHorizontalAlignment.ALIGN_CENTER);
		
		root.add(mainPanel);
		init();
		updateWidgetSizes();
	}
	
	private void updateWidgetSizes() {
		String contentWidth = "90%";
		MAIN_WIDTH = 700;
		if (isMobileView) {
			MAIN_WIDTH = Window.getClientWidth();
			contentWidth = "95%";
		}
		mainPanel.setWidth(MAIN_WIDTH + "px");
		mainPanel.setHeight(Window.getClientHeight() + "px");
		contentPanel.setWidth(CONTENT_WIDTH + "px");
	}
	
	/**
	 * Initialize raport view.
	 * Create blank raport page.
	 */
	private void init() {
		
		createTreePanel();
		contentPanel.add(treePanel);
		contentPanel.add(unitPanel);
		contentPanel.add(raportPanel);
		contentPanel.showWidget(contentPanel.getWidgetIndex(treePanel));
		String unitKey=Window.Location.getParameter("unitKey");
		if(unitKey!=null) {
		deviceTreeService.getUnit(unitKey, new AsyncCallback<Unit>() {
			public void onSuccess(Unit u){
				DebugClientSide.log(u+"");
				selectedUnit=u;
				Date date = new Date();
				DateTimeFormat dtf = DateTimeFormat.getFormat("dd.MM.yyyy");
				selectedRaport = new Raport();
				selectedRaport.setCompanyName(selectedCompany.getCompanyName());
				selectedRaport.setUnitName(u.getUnit());
				selectedRaport.setUnitKey(u.getUnitKey());
				selectedRaport.setDate(dtf.format(date, TimeZone.createTimeZone(0)));
				deviceTreeService.getRaportData(selectedRaport, getRaportDataCallback);
			}

			@Override
			public void onFailure(Throwable caught) {
				// TODO Auto-generated method stub
				
			}
		});
		}
		//devTree.fetchDepartments(selectedCompany);
		DebugClientSide.log("algus");
		DebugClientSide.log(devTree.getItem(0).getUserObject().toString());
		/*
		DebugClientSide.log(devTree.getItem(0).asTreeItem().getChildCount()+"");
		DebugClientSide.log(devTree.getItem(0).getChild(0)+"");
		DebugClientSide.log(((Unit)devTree.getItem(0).getChild(0).getChild(0).getUserObject()).getUnit()+"");
		DebugClientSide.log(((Unit)devTree.getItem(0).getChild(0).getChild(0).getUserObject()).getUnitKey()+"");*/
	}
	
	private void createTreePanel() {
		treePanel = new VerticalPanel();
		treePanel.setWidth("100%");
		
		Label lLabel1 = new Label("Raportid");
		lLabel1.setStyleName("backSaveLabel noPointer");
		
		devTree = new DeviceTree(deviceTreeService);
		devTree.getElement().addClassName("gwt-Tree");
		devTree.addSelectionHandler(new SelectionHandler<TreeItem>() {
			
			@Override
			public void onSelection(SelectionEvent<TreeItem> event) {
				System.out.println("valitud: " + event.getSelectedItem().getText());
				TreeItem item = (TreeItem) event.getSelectedItem();
				if (item.getUserObject() instanceof Unit && item.getChildCount() == 0) {
					System.out.println(item.getText() + " selected..");
					selectedUnit = (Unit)item.getUserObject();
					deviceTreeService.getRaports(selectedUnit.getUnitKey(), getRaportsCallback);
				} else {
					if (item.getUserObject() instanceof Company && item.getChildCount() == 0) {
						selectedCompany = (Company)item.getUserObject();
						System.out.println(item.getText() + " selected..");
						devTree.fetchDepartments((Company)item.getUserObject());
					}
					if (item.getUserObject() instanceof Department && item.getChildCount() == 0) {
						selectedDepartment = (Department)item.getUserObject();
						System.out.println(item.getText() + " selected..");
						devTree.fetchUnits((Department)item.getUserObject());
					}
					TreeItem selItem = event.getSelectedItem();
					boolean state = selItem.getState();
				    TreeItem parent = selItem.getParentItem();
				    selItem.getTree().setSelectedItem(parent, false); // null is ok
				    if(parent != null)
				        parent.setSelected(false);  // not compulsory
				    selItem.setState(!state, false);
				}
			}
			
		});
		
		treePanel.add(lLabel1);
		treePanel.add(devTree);
	}
	
	private void createUnitPanel() {
		unitPanel.clear();
		unitPanel.setWidth("100%");
		
		Label lNewRaport = new Label("Uus raport");
		lNewRaport.setStyleName("backSaveLabel");
		lNewRaport.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				Date date = new Date();
				DateTimeFormat dtf = DateTimeFormat.getFormat("dd.MM.yyyy");
				selectedRaport = new Raport();
				selectedRaport.setCompanyName(selectedCompany.getCompanyName());
				selectedRaport.setUnitName(selectedUnit.getUnit());
				selectedRaport.setUnitKey(selectedUnit.getUnitKey());
				DebugClientSide.log(selectedUnit.getUnitKey());
				selectedRaport.setDate(dtf.format(date, TimeZone.createTimeZone(0)));
				deviceTreeService.getRaportData(selectedRaport, getRaportDataCallback);
			}
			
		});
		Label lBack = new Label("Tagasi");
		lBack.setStyleName("backSaveLabel");
		final Button lBackButton = new Button();
		lBackButton.setStyleName("backButton");
		lBackButton.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				contentPanel.showWidget(contentPanel.getWidgetIndex(treePanel));
			}
			
		});
		lBack.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				lBackButton.fireEvent(event);
			}
			
		});
		
		HorizontalPanel buttonsPanel = new HorizontalPanel();
		buttonsPanel.setStyleName("backSavePanel");
		buttonsPanel.add(lBackButton);
		buttonsPanel.add(lBack);
		buttonsPanel.add(lNewRaport);
		buttonsPanel.setCellWidth(lBackButton, "7%");
		buttonsPanel.setCellWidth(lBack, "43%");
		buttonsPanel.setCellWidth(lNewRaport, "50%");
		buttonsPanel.setCellHorizontalAlignment(lNewRaport, HasHorizontalAlignment.ALIGN_RIGHT);
		unitPanel.add(buttonsPanel);
		
		//Header Panel
		HorizontalPanel headerPanel = AhoWidgets.createThinContentHeader(selectedUnit.getUnit());
		unitPanel.add(headerPanel);
		
		//Raports list
		for (final Raport raport : raports) {
			Label lRaport = new Label("Raport " + raport.getRaportID() + "  " + raport.getDate());
			lRaport.setStyleName("aho-listItem");
			lRaport.addClickHandler(new ClickHandler() {
				
				@Override
				public void onClick(ClickEvent event) {
					//createLocationListPanel(((Label)(event.getSource())).getText());
					selectedRaport = raports.get(raports.indexOf(raport));
					deviceTreeService.getRaportData(selectedRaport, getRaportDataCallback);
				}
				
			});
			unitPanel.add(lRaport);
		}
		
		contentPanel.showWidget(contentPanel.getWidgetIndex(unitPanel));
	}
	
	/**
	 * Create editable new raport view and populate it with data.
	 */
	private void createRaport(boolean isEditable) {
		raportPanel.clear();
		raportPanel.setWidth("100%");
		
		//Back panel
		Label lBack = new Label("Tagasi");
		lBack.setStyleName("backSaveLabel");
		final Button lBackButton = new Button();
		lBackButton.setStyleName("backButton");
		lBackButton.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				contentPanel.showWidget(contentPanel.getWidgetIndex(unitPanel));
			}
			
		});
		lBack.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				lBackButton.fireEvent(event);
			}
			
		});
		
		Label lAho=new Label("Mootmised");
		lAho.setStyleName("backSaveLabel");
		final Button lAhoButton=new Button();
		lAhoButton.setStyleName("backButton");
		lAhoButton.addClickHandler(new ClickHandler() {
			  public void onClick(ClickEvent e) {
				  Window.Location.assign("/Aho.html");
			  }
		});
		lAho.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent e) {
				lAhoButton.fireEvent(e);;
			}
		});
		
		
		Label lSave = new Label("Salvesta");
		lSave.setStyleName("backSaveLabel");
		lSave.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				boolean leitud=false;
			    List<Measurement> kahtlased=new ArrayList<Measurement>();
				for(int i=0; i<raportDataList.size(); i++) {
					if(raportDataList.get(i).getMarking().contentEquals("alarm") || 
							raportDataList.get(i).getMarking().contentEquals("hoiatus")) {
						kahtlased.add(raportDataList.get(i));
					}
				}
				if(kahtlased.size()>0) {
					// Debug.log("kahtlased: "+kahtlased.toString());
//					deviceTreeService.sendMail(, subject, message, replyto, callback);
					 String s="Probleem: ";
                     for(int i=0; i<kahtlased.size(); i++) {
                    	 Measurement k=kahtlased.get(i);
                    	 s+="\nSeadme nimi: "+k.getDeviceName();
                    	 s+="\nSeadme id: "+k.getDeviceID();
                    	 s+="\nTeatis: "+k.getMarking();
                    	 s+="\nKommentaar: "+k.getComment();
                    	 s+="\n";
                     }
                     Debug.log(s);
                     
				}
				selectedRaport.setRaportID(((TextBox)inputRaportNr).getText());
				selectedRaport.setMeasurerName(((TextBox)inputMeasurerName).getText());
				selectedRaport.setMeasurerPhone(((TextBox)inputMeasurerPhone).getText());
				selectedRaport.setDate(((TextBox)inputDate).getText());
				deviceTreeService.storeRaport(selectedRaport, storeRaportCallback);
			}
			
		});
		Label lPdf = new Label("PDF");
		lPdf.setStyleName("backSaveLabel");
		lPdf.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				//String url = GWT.getModuleBaseURL() + "downloadService?fileInfo1=" + fileInfo1;
				//String url = Window.Location.getHref().replace("Raports.html", "getRaport");
				//Window.open( url, "_blank", "status=0,toolbar=0,menubar=0,location=0");
				Window.open(Window.Location.getHref().replace("Raports.html", "raport.html?raport=" + selectedRaport.getRaportKey()), "_blank", "");
			}
			
		});
		HorizontalPanel buttonsPanel = new HorizontalPanel();
		buttonsPanel.setStyleName("backSavePanel");
		buttonsPanel.add(lBackButton);
		buttonsPanel.add(lBack);
		buttonsPanel.add(lAho);
		buttonsPanel.setCellWidth(lBackButton, "7%");
		buttonsPanel.setCellWidth(lBack, "43%");
		if (isEditable) {
			buttonsPanel.add(lSave);
			buttonsPanel.setCellWidth(lSave, "50%");
			buttonsPanel.setCellHorizontalAlignment(lSave, HasHorizontalAlignment.ALIGN_RIGHT);
		} else {
			buttonsPanel.add(lPdf);
			buttonsPanel.setCellWidth(lPdf, "50%");
			buttonsPanel.setCellHorizontalAlignment(lPdf, HasHorizontalAlignment.ALIGN_RIGHT);
		}
		raportPanel.add(buttonsPanel);
		
		//Header panel
		HorizontalPanel raportHeaderPanel = AhoWidgets.createContentHeader("Raport");
		raportPanel.add(raportHeaderPanel);
		
		//Top info panel
		Widget lCompanyName = AhoWidgets.createLabel("Ettev\u00F5te", "aho-label1", null);
		Widget inputCompanyName = AhoWidgets.createLabel(selectedRaport.getCompanyName(), "aho-label1 alignRight", HasHorizontalAlignment.ALIGN_RIGHT);
		Widget lRaportNr = AhoWidgets.createLabel("Esmane raport nr.", "aho-label1", null);
		if (isEditable) {
			inputRaportNr = AhoWidgets.createTextbox("aho-textbox1", selectedRaport.getRaportID(), "Raporti nr.");
		} else {
			inputRaportNr = AhoWidgets.createLabel(selectedRaport.getRaportID(), "aho-label1 alignRight", HasHorizontalAlignment.ALIGN_RIGHT);
		}
		Widget lUnitName = AhoWidgets.createLabel("\u00DCksus", "aho-label1", null);
		Widget inputUnitName = AhoWidgets.createLabel(selectedRaport.getUnitName(), "aho-label1 alignRight", HasHorizontalAlignment.ALIGN_RIGHT);
		HorizontalPanel companyNamePanel = AhoWidgets.createSingleRowDataPanel(lCompanyName, inputCompanyName, "aho-panel1");
		raportPanel.add(companyNamePanel);
		HorizontalPanel raportNrPanel = AhoWidgets.createSingleRowDataPanel(lRaportNr, inputRaportNr, "aho-panel1");
		raportPanel.add(raportNrPanel);
		HorizontalPanel measuringLocationPanel = AhoWidgets.createSingleRowDataPanel(lUnitName, inputUnitName, "aho-panel1");
		raportPanel.add(measuringLocationPanel);
		
		//Measurement results panel
		VerticalPanel reportDataTable = createDataTable();
		raportPanel.add(reportDataTable);
		
		//Bottom info panel
		Widget lMeasurerInfo = AhoWidgets.createLabel("M\u00F5\u00F5tmisi teostas:", "aho-label1", null);
		Widget lDate = AhoWidgets.createLabel("Kuup\u00E4ev", "aho-label1", null);
		if (isEditable) {
			inputMeasurerName = AhoWidgets.createTextbox("aho-textbox1", selectedRaport.getMeasurerName());
			inputMeasurerName.getElement().setPropertyString("placeholder", "Nimi");
			inputMeasurerPhone = AhoWidgets.createTextbox("aho-textbox1", selectedRaport.getMeasurerPhone());
			inputMeasurerPhone.getElement().setPropertyString("placeholder", "Telefoni nr.");
			inputDate = AhoWidgets.createTextbox("aho-textbox1", selectedRaport.getDate());
			inputDate.getElement().setPropertyString("placeholder", "Kuup\u00E4ev");
		} else {
			inputMeasurerName = AhoWidgets.createLabel(selectedRaport.getMeasurerName(), "aho-label1 alignRight", HasHorizontalAlignment.ALIGN_RIGHT);
			inputMeasurerPhone = AhoWidgets.createLabel(selectedRaport.getMeasurerPhone(), "aho-label1 alignRight", HasHorizontalAlignment.ALIGN_RIGHT);
			inputDate = AhoWidgets.createLabel(selectedRaport.getDate(), "aho-label1 alignRight", HasHorizontalAlignment.ALIGN_RIGHT);
		}
		HorizontalPanel measurerPanel = AhoWidgets.createSingleRowDataPanel(lMeasurerInfo, inputMeasurerName, "aho-panel1 closeBottom");
		raportPanel.add(measurerPanel);
		HorizontalPanel measurerPhonePanel = AhoWidgets.createSingleRowDataPanel(AhoWidgets.createLabel("", "aho-label1", null), inputMeasurerPhone, "aho-panel1");
		raportPanel.add(measurerPhonePanel);
		HorizontalPanel dateTimePanel = AhoWidgets.createSingleRowDataPanel(lDate, inputDate, "aho-panel1");
		raportPanel.add(dateTimePanel);
		
		AbsolutePanel emptyPanel = new AbsolutePanel();
		emptyPanel.setStyleName("aho-markingBlankPanel");
		raportPanel.add(emptyPanel);
		
		contentPanel.showWidget(contentPanel.getWidgetIndex(raportPanel));
	}
	
	/**
	 * Create data table with measurement data.
	 * @return AbsolutePanel containing measurement data table.
	 */
	private VerticalPanel createDataTable() {
		CellTable.Resources historyTableRes = GWT.create(TableRes.class);
		VerticalPanel tablePanel = new VerticalPanel();
		tablePanel.setStyleName("aho-panel1 table2");
		tablePanel.setWidth("100%");
		// Create a CellTable with corresponding columns.
	    CellTable<Measurement> table = new CellTable<Measurement>(raportDataList.size(), historyTableRes);
	    TextColumn<Measurement> idColumn = new TextColumn<Measurement>() {
	    	@Override
	    	public String getValue(Measurement measurement) {
	    		return "" + measurement.getDeviceID();
	    	}
	    };
	    TextColumn<Measurement> deviceNameColumn = new TextColumn<Measurement>() {
	    	@Override
	    	public String getValue(Measurement measurement) {
	    		return measurement.getDeviceName();
	    	}
	    };
	    Column<Measurement, SafeHtml> markingAColumn = new Column<Measurement, SafeHtml>(new SafeHtmlCell()) {

			@Override
			public SafeHtml getValue(Measurement measurement) {
				return measurement.getMarking().equals("alarm") ? SafeHtmlUtils.fromTrustedString(AhoWidgets.getAHOImage("a", 24).toString()): null;
			}
	    	
	    };
	    Column<Measurement, SafeHtml> markingHColumn = new Column<Measurement, SafeHtml>(new SafeHtmlCell()) {

			@Override
			public SafeHtml getValue(Measurement measurement) {
				return measurement.getMarking().equals("hoiatus") ? SafeHtmlUtils.fromTrustedString(AhoWidgets.getAHOImage("h", 24).toString()): null;
			}
	    	
	    };
	    Column<Measurement, SafeHtml> markingOColumn = new Column<Measurement, SafeHtml>(new SafeHtmlCell()) {

			@Override
			public SafeHtml getValue(Measurement measurement) {
				return measurement.getMarking().equals("ok") ? SafeHtmlUtils.fromTrustedString(AhoWidgets.getAHOImage("o", 24).toString()): null;
			}
	    	
	    };
	    TextColumn<Measurement> commentColumn = new TextColumn<Measurement>() {
	    	@Override
	    	public String getValue(Measurement measurement) {
	    		return measurement.getComment()
	    		  + " " + measurement.getDEcomment() + " " + measurement.getNDEcomment() + " " +
	    		  		measurement.getMPcomment() + " " + measurement.getTPcomment();
	    	}
	    };
	    
	    // Add the columns.
	    idColumn.setCellStyleNames("idCell");
	    table.addColumn(idColumn, "ID nr.");
	    table.addColumn(deviceNameColumn, "Seadme nimetus");
	    //table.addColumn(markingAColumn, "A");
	    markingAColumn.setCellStyleNames("markingCell");
	    markingHColumn.setCellStyleNames("markingCell");
	    markingOColumn.setCellStyleNames("markingCell");
	    table.addColumn(markingAColumn, SafeHtmlUtils.fromTrustedString(AhoWidgets.getAHOImage("a", 24).toString()));
	    table.addColumn(markingHColumn, SafeHtmlUtils.fromTrustedString(AhoWidgets.getAHOImage("h", 24).toString()));
	    table.addColumn(markingOColumn, SafeHtmlUtils.fromTrustedString(AhoWidgets.getAHOImage("o", 24).toString()));
	    table.addColumn(commentColumn, "Kommentaar");

	    // Set the width of the table and put the table in fixed width mode.
	    table.setWidth("100%", true);

	    // Set the width of each column.
	    table.setColumnWidth(0, "100px");
	    table.setColumnWidth(1, "28%");
	    table.setColumnWidth(2, "35px");
	    table.setColumnWidth(3, "35px");
	    table.setColumnWidth(4, "35px");
	    table.setColumnWidth(5, "72%");

	    // Set the total row count. This isn't strictly necessary, but it affects
	    // paging calculations, so its good habit to keep the row count up to date.
	    //table.setRowCount(raportDataList.size(), true);

	    // Push the data into the widget.
	    table.setRowData(0, raportDataList);
	    //scrollPanel = new ScrollPanel();
	    //scrollPanel.add(table);
	    //scrollPanel.setWidth("92%");
	    tablePanel.add(table);
	    tablePanel.setCellHorizontalAlignment(table, HasHorizontalAlignment.ALIGN_CENTER);
	    tablePanel.setWidth("100%");
	    
	    //Marking definitions panel
	    AbsolutePanel markingPanel = new AbsolutePanel();
	    markingPanel.setSize("100%", "50px");
		markingPanel.add(AhoWidgets.getAHOImage("a", 14), 0, 5);
		markingPanel.add(AhoWidgets.getAHOImage("h", 14), 0, 20);
		markingPanel.add(AhoWidgets.getAHOImage("o", 14), 0, 35);
	    Label markingA = new Label("Alarm. Oluline k\u00F5rvalekalle normist. Soovitatav tegevus");
	    Label markingH = new Label("Hoiatus. T\u00E4heldatav k\u00F5rvalekalle normist. V\u00E4lja selgitada p\u00F5hjus v\u00F5i j\u00E4lgida arengut.");
	    Label markingO = new Label("N\u00E4itajad normi piirides");
	    markingA.setStyleName("smallTextLabel");
	    markingH.setStyleName("smallTextLabel");
	    markingO.setStyleName("smallTextLabel");
	    markingPanel.add(markingA, 25, 5);
	    markingPanel.add(markingH, 25, 20);
	    markingPanel.add(markingO, 25, 35);
	    tablePanel.add(markingPanel);
	    return tablePanel;
	}
	
	public static Raport getSelectedRaport() {
		return selectedRaport;
	}
	
	public static List<Measurement> getRaportData() {
		return raportDataList;
	}
	
	/**
	 * Table resources interface for deeper GWT table customization.
	 * @author rando
	 *
	 */
	public interface TableRes extends CellTable.Resources {

		@NotStrict
		@Source({CellTable.Style.DEFAULT_CSS, "Table.css"})
		TableStyle cellTableStyle();
		
		interface TableStyle extends CellTable.Style {}
		}
}
